ClassEntry (Java SE 26 & JDK 26)
Description: declaration: module: java.base, package: java.lang.classfile.constantpool, interface: ClassEntry
Keywords: java.lang.classfile.constantpool.ClassEntry interface

# Interface ClassEntry

All Superinterfaces:
  `LoadableConstantEntry, PoolEntry`

public sealed interface ClassEntry extends LoadableConstantEntry
Models a `CONSTANT_Class_info` structure, representing a reference type, in the constant pool of a `class` file.

The use of a `ClassEntry` is modeled by a `ClassDesc` that is not primitive. Conversions are through `ConstantPoolBuilder.classEntry(ClassDesc)` and `asSymbol()`.

A `ClassEntry` is composite:

    ClassEntry(Utf8Entry name)

where `name` represents:

- The internal form of a binary name (JVMS 4.2.1), if and only if this `ClassEntry` represents a class or interface, such as `java/lang/String` for the `String` class.
- A field descriptor string (JVMS 4.3.2) representing an array type, if and only if this `ClassEntry` represents an array type, such as `[I` for the `int[]` type, or `[Ljava/lang/String;` for the `String[]` type.

A field descriptor string for an array type can be distinguished by its leading `'['` character.

API Note:
  The internal form of a binary name, where all occurrences of `.` in the name are replaced by `/`, is informally known as an internal name. This concept also applies to package names in addition to class and interface names.
See Java Virtual Machine Specification:
  4.4.1 The `CONSTANT_Class_info` Structure
Since:
  24
See Also:
  - `ConstantPoolBuilder::classEntry`
  - `ClassDesc`

- ## Field Summary

  ### Fields declared in interface PoolEntry

  `TAG_CLASS, TAG_DOUBLE, TAG_DYNAMIC, TAG_FIELDREF, TAG_FLOAT, TAG_INTEGER, TAG_INTERFACE_METHODREF, TAG_INVOKE_DYNAMIC, TAG_LONG, TAG_METHOD_HANDLE, TAG_METHOD_TYPE, TAG_METHODREF, TAG_MODULE, TAG_NAME_AND_TYPE, TAG_PACKAGE, TAG_STRING, TAG_UTF8`
  Modifier and Type
  Field
  Description
  `static final int`
  `TAG_CLASS`
  The tag for `CONSTANT_Class` constant kind.
  `static final int`
  `TAG_DOUBLE`
  The tag for `CONSTANT_Double` constant kind.
  `static final int`
  `TAG_DYNAMIC`
  The tag for `CONSTANT_Dynamic` constant kind.
  `static final int`
  `TAG_FIELDREF`
  The tag for `CONSTANT_Fieldref` constant kind.
  `static final int`
  `TAG_FLOAT`
  The tag for `CONSTANT_Float` constant kind.
  `static final int`
  `TAG_INTEGER`
  The tag for `CONSTANT_Integer` constant kind.
  `static final int`
  `TAG_INTERFACE_METHODREF`
  The tag for `CONSTANT_InterfaceMethodref` constant kind.
  `static final int`
  `TAG_INVOKE_DYNAMIC`
  The tag for `CONSTANT_InvokeDynamic` constant kind.
  `static final int`
  `TAG_LONG`
  The tag for `CONSTANT_Long` constant kind.
  `static final int`
  `TAG_METHOD_HANDLE`
  The tag for `CONSTANT_MethodHandle` constant kind.
  `static final int`
  `TAG_METHOD_TYPE`
  The tag for `CONSTANT_MethodType` constant kind.
  `static final int`
  `TAG_METHODREF`
  The tag for `CONSTANT_Methodref` constant kind.
  `static final int`
  `TAG_MODULE`
  The tag for `CONSTANT_Module` constant kind.
  `static final int`
  `TAG_NAME_AND_TYPE`
  The tag for `CONSTANT_NameAndType` constant kind.
  `static final int`
  `TAG_PACKAGE`
  The tag for `CONSTANT_Package` constant kind.
  `static final int`
  `TAG_STRING`
  The tag for `CONSTANT_String` constant kind.
  `static final int`
  `TAG_UTF8`
  The tag for `CONSTANT_Utf8` constant kind.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `asInternalName()`
  Returns the represented reference type, as the internal form of a binary name or an array descriptor string.
  `ClassDesc`
  `asSymbol()`
  Returns the represented reference type, as a symbolic descriptor.
  `default ConstantDesc`
  `constantValue()`
  Returns a symbolic descriptor of this constant.
  `boolean`
  `matches(ClassDesc desc)`
  Returns whether this entry describes the given reference type.
  `Utf8Entry`
  `name()`
  Returns the `Utf8Entry` referred by this structure.

  ### Methods declared in interface LoadableConstantEntry

  `typeKind`
  Modifier and Type
  Method
  Description
  `default TypeKind`
  `typeKind()`
  Returns the data type of this constant.

  ### Methods declared in interface PoolEntry

  `constantPool, index, tag, width`
  Modifier and Type
  Method
  Description
  `ConstantPool`
  `constantPool()`
  Returns the constant pool this entry is from.
  `int`
  `index()`
  Returns the index within the constant pool corresponding to this entry.
  `int`
  `tag()`
  Returns the constant pool tag that describes the type of this entry.
  `int`
  `width()`
  Returns the number of constant pool slots this entry consumes.

- ## Method Details

  - ### constantValue

    default ConstantDesc constantValue()
    Returns a symbolic descriptor of this constant.

    This is equivalent to `asSymbol()`.

    Specified by:
      `constantValue` in interface `LoadableConstantEntry`
    Returns:
      a symbolic descriptor of this constant
    See Also:
      - `ConstantPoolBuilder.loadableConstantEntry(ConstantDesc)`

  - ### name

    Utf8Entry name()
    Returns the `Utf8Entry` referred by this structure. If the value of the UTF8 starts with a `[`, this represents an array type and the value is a descriptor string; otherwise, this represents a class or interface and the value is the internal form of a binary name.
    Returns:
      the `Utf8Entry` referred by this structure
    See Also:
      - `ConstantPoolBuilder::classEntry(Utf8Entry)`

  - ### asInternalName

    String asInternalName()
    Returns the represented reference type, as the internal form of a binary name or an array descriptor string. This is a shortcut for `name().stringValue()`.
    Returns:
      the represented reference type, as the internal form of a binary name or an array descriptor string

  - ### asSymbol

    ClassDesc asSymbol()
    Returns the represented reference type, as a symbolic descriptor. The returned descriptor is never primitive.
    API Note:
      If only symbol equivalence is desired, `matches` should be used. It requires reduced parsing and can improve `class` file reading performance.
    Returns:
      the represented reference type, as a symbolic descriptor
    See Also:
      - `ConstantPoolBuilder::classEntry(ClassDesc)`

  - ### matches

    boolean matches(ClassDesc desc)
    Returns whether this entry describes the given reference type. Returns `false` if `desc` is primitive.
    Parameters:
      `desc` - the reference type
    Returns:
      whether this entry describes the given reference type
    Since:
      25